"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = require("react");
function useStateValidator(state, validator, initialValidity) {
    if (initialValidity === void 0) { initialValidity = [undefined]; }
    var validatorFn = react_1.useRef(validator);
    var _a = react_1.useState(initialValidity), validity = _a[0], setValidity = _a[1];
    var validate = react_1.useCallback(function () {
        if (validatorFn.current.length === 2) {
            validatorFn.current(state, setValidity);
        }
        else {
            setValidity(validatorFn.current(state));
        }
    }, [state]);
    react_1.useEffect(function () {
        validate();
    }, [state]);
    return [validity, validate];
}
exports.default = useStateValidator;
